routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CompanieController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\Auth\SocialiteController;
use App\Http\Controllers\ItemController;
use App\Http\Controllers\SellController;
use App\Http\Controllers\SellSummaryController;
use App\Jobs\SendEmailJob;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Auth::routes([
    'register' => false
]);

Route::get('/auth/redirect/{provider}',[SocialiteController::class,'redirect'])->name('auth.redirect');
Route::get('/auth/callback/{provider}',[SocialiteController::class,'callback'])->name('auth.callback');

Route::middleware('auth')->group(function(){
    
    Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => App\Http\Controllers\LanguageController::class,'switch']);

    Route::get('/', function () {
        return view('home');
    });

    Route::get('tz/{tz}', ['as' => 'tz.switch', 'uses' => App\Http\Controllers\TimezoneController::class,'switch']);

    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('employees',EmployeeController::class)->except(['destroy']);
    Route::resource('sells',SellController::class)->except(['destroy']);
    Route::get('/employees/{employee}/destroy',[EmployeeController::class,'destroy'])->name('employees.destroy');
    
    Route::resource('companies',CompanieController::class)->except(['destroy']);
    Route::resource('items',ItemController::class)->except(['destroy']);
    Route::resource('sellSummaries',SellSummaryController::class)->except(['destroy']);
    Route::get('/items/{item}/destroy',[ItemController::class,'destroy'])->name('items.destroy');
    Route::get('/sells/{sell}/destroy',[SellController::class,'destroy'])->name('sells.destroy');

    Route::get('/companies/{company}/destroy',[CompanieController::class,'destroy'])->name('companies.destroy');
    
    Route::get('test/email', function(){
        $send_mail = 'lim.liete@gmail.com';
        dispatch(new App\Jobs\SendEmailJob($send_mail));
        dd('send mail successfully !!');
    })->name('sendEmail');
    

    

});

app/Models/Employee.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Employee extends Model
{
    use HasFactory;

    protected $fillable = [
        'first_name',
        'last_name',
        'companie_id',
        'email',
        'phone',
        'password',
        'created_by_id',
        'updated_by_id'
    ];

    public function companie(){
        return $this->belongsTo(Companie::class);
    }
    
}

app/Http/Controllers/EmployeeController.php
<?php

namespace App\Http\Controllers;

use App\Models\Companie;
use App\Models\Employee;
use Illuminate\Http\Request;
use App\Http\Requests\EmployeeStoreRequest;
use App\Http\Requests\EmployeeUpdateRequest;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\Auth;

class EmployeeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $companies = Companie::select('id', 'name')->latest()->get();
        // $employees = Employee::latest()->paginate(10);
        // return view('employee.index',compact('employees'));
        return view('employee.index',compact('companies'));
    }

    

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $companies = Companie::select('id','name')->latest()->get();
        return view('employee.create',compact('companies'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(EmployeeStoreRequest $request)
    {
        Employee::create([
            'first_name' => $request->first_name,
            'last_name' => $request->last_name,
            'companie_id' => $request->companie_id,
            'email' => $request->email,
            'phone' => $request->phone,
            'password' => bcrypt($request->password),
            'created_by_id' => $request->created_by_id,
            'updated_by_id' => $request->updated_by_id
        ]);

        return redirect()->route('employees.create')->with('message',['text' => __('employee.status2'), 'class' => 'success']);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Employee $employee)
    {
        $companies = Companie::select('id','name')->get();
        return view('employee.edit',compact('employee','companies'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(EmployeeUpdateRequest $request, Employee $employee)
    {
        if($request->password){
            $employee->update([
                'first_name' => $request->first_name,
                'last_name' => $request->last_name,
                'companie_id' => $request->companie_id,
                'email' => $request->email,
                'phone' => $request->phone,
                'password' => bcrypt($request->password),
                'updated_by_id' => $request->updated_by_id
            ]);
        }else{
            $employee->update([
                'first_name' => $request->first_name,
                'last_name' => $request->last_name,
                'companie_id' => $request->companie_id,
                'email' => $request->email,
                'phone' => $request->phone,
                // 'password' => bcrypt($request->password),
                'updated_by_id' => $request->updated_by_id
            ]);
        }

        

        return redirect()->route('employees.edit',$employee->id)->with('message',['text' => __('employee.status3'), 'class' => 'success']);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Employee $employee)
    {
        $employee->delete();
        return redirect()->route('employees.index')->with('message',['text' => __('employee.status4'), 'class' => 'success']);
    }

    public function employee(){
        $data = "Data All Employee";
        return response()->json($data, 200);
    }

    public function employeeAuth() {
        $data = "Welcome " . Auth::user()->name;
        return response()->json($data, 200);
    }
}

app/View/Components/Employees.php
<?php

namespace App\View\Components;

use App\Models\Employee;
use Illuminate\View\Component;

class Employees extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $employees = Employee::count();
        return view('components.employees',compact('employees'));
    }
}

resources/views/employee/create.blade.php
@extends('layouts.app')
@section('title')
{{trans('employee.title2') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')
        
        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                    {{ __('employee.title2') }}
                    <a href="{{ route('employees.index') }}" class="btn btn-sm btn-secondary float-right">{{ trans('employee.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('employees.store')}}" method="POST">
                        @csrf
                        <div class="row">
                            <div class="col-6">
                                <label for="">{{ trans('employee.table1') }}</label>
                                <input type="text" class="form-control" name="first_name" value="{{ old('first_name')}}">
                                @include('layouts.error', ['name' => 'first_name'])
                            </div>
                            <div class="col-6">
                                <label for="">{{ trans('employee.table2') }}</label>
                                <input type="text" class="form-control" name="last_name" value="{{ old('last_name')}}">
                                @include('layouts.error', ['name' => 'last_name'])
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-12">
                                <label for="">Password</label>
                                <input type="password" class="form-control" name="password" value="{{ old('password')}}">
                                @include('layouts.error', ['name' => 'password'])
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-md-12">
                                <label for="">{{ trans('employee.table3') }}</label>
                                <select name="companie_id" class="form-control">
                                    <option value="" selected disabled>Select Companie</option>
                                    @forelse ($companies as $companie)
                                        <option value="{{ $companie->id }}">{{ $companie->name }}</option>
                                    @empty
                                        <option value="" selected>{{ trans('employee.status1') }}</option>
                                    @endforelse
                                </select>
                                @include('layouts.error', ['name' => 'companie_id'])
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-6">
                                <label for="">{{ trans('employee.table4') }}</label>
                                <input type="email" class="form-control" name="email" value="{{ old('email')}}">
                                @include('layouts.error', ['name' => 'email'])
                            </div>
                            <div class="col-6">
                                <label for="">{{ trans('employee.table5') }}</label>
                                <input type="text" class="form-control" name="phone" value="{{ old('phone')}}">
                                @include('layouts.error', ['name' => 'phone'])
                            </div>
                            <div class="col-6" style="display: none;">
                                <label for="">{{ __('Created By Id') }}</label>
                                <input type="text" class="form-control" name="created_by_id" value="{{ Auth::id() }}">
                                @include('layouts.error', ['name' => 'created_by_id'])
                            </div>
                            <div class="col-6" style="display: none;">
                                <label for="">{{ __('Updated By Id') }}</label>
                                <input type="text" class="form-control" name="updated_by_id" value="{{ Auth::id() }}">
                                @include('layouts.error', ['name' => 'updated_by_id'])
                            </div>
                        </div>
                        <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit">{{ trans('employee.btn1') }}</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/employee/edit.blade.php
@extends('layouts.app')
@section('title')
{{trans('employee.title3') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                    {{ trans('employee.title3') }}
                    <a href="{{ route('employees.index') }}" class="btn btn-sm btn-secondary float-right"> {{ trans('companie.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('employees.update',$employee->id)}}" method="POST">
                        @csrf
                        @method('PUT')
                        <div class="row">
                            <div class="col-6">
                                <label for=""> {{ trans('employee.table1') }}</label>
                                <input type="text" class="form-control" name="first_name" value="{{ $employee->first_name }}">
                                @include('layouts.error', ['name' => 'first_name'])
                            </div>
                            <div class="col-6">
                                <label for=""> {{ trans('employee.table2') }}</label>
                                <input type="text" class="form-control" name="last_name" value="{{ $employee->last_name }}">
                                @include('layouts.error', ['name' => 'last_name'])
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-12">
                                <label for=""> Password</label>
                                <input type="password" class="form-control" name="password" >
                                @include('layouts.error', ['name' => 'password'])
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-md-12">
                                <label for=""> {{ trans('employee.table3') }}</label>
                                <select name="companie_id" class="form-control">
                                    <option value="" disabled>Select Companie</option>
                                    @forelse ($companies as $companie)
                                    @php
                                    if($companie->id == $employee->companie_id){
                                    $select = "selected";
                                    }else{
                                    $select = "";
                                    }
                                    echo "<option $select value='$companie->id'>".$companie['name']."</option>"
                                    @endphp
                                    @empty
                                    <option value="" selected> {{ trans('employee.status1') }}</option>
                                    @endforelse
                                </select>
                                @include('layouts.error', ['name' => 'companie_id'])
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-6">
                                <label for=""> {{ trans('employee.table4') }}</label>
                                <input type="email" class="form-control" name="email" value="{{ $employee->email }}">
                                @include('layouts.error', ['name' => 'email'])
                            </div>
                            <div class="col-6">
                                <label for=""> {{ trans('employee.table5') }}</label>
                                <input type="text" class="form-control" name="phone" value="{{ $employee->phone }}">
                                @include('layouts.error', ['name' => 'phone'])
                            </div>
                            <div class="col-6" style="display: none;">
                                <label for="">{{ __('Created By Id') }}</label>
                                <input type="text" class="form-control" name="created_by_id" value="{{ $employee->created_by_id }}">
                                @include('layouts.error', ['name' => 'created_by_id'])
                            </div>
                            <div class="col-6" style="display: none;">
                                <label for="">{{ __('Updated By Id') }}</label>
                                <input type="text" class="form-control" name="updated_by_id" value="{{ Auth::id() }}">
                                @include('layouts.error', ['name' => 'updated_by_id'])
                            </div>
                        </div>
                        <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit"> {{ trans('employee.title3') }}</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/employee/index.blade.php
@extends('layouts.app')
@section('title')
    {{ __('employee.title1') }}
@endsection
@section('content')
    <div class="container">
        <div class="row justify-content-center">

            @include('layouts.notif')

            <div class="col-md-12 mt-2">
                <div class="card">
                    <div class="card-header">
                        {{ __('employee.title1') }}
                        <a href="{{ route('employees.create') }}"
                            class="btn btn-sm btn-primary float-right">{{ __('employee.btn1') }}</a>
                    </div>
                    <div class="card-body">
                        <br>
                        <!-- MULAI DATE RANGE PICKER -->
                        <div class="row input-daterange">
                            <div class="col-md-6">
                                <input type="text" name="from_date" id="from_date" class="form-control"
                                    placeholder="{{ __('employee.fromdate') }}" readonly />
                            </div>
                            <div class="col-md-6">
                                <input type="text" name="to_date" id="to_date" class="form-control"
                                    placeholder="{{ __('employee.todate') }}" readonly />
                            </div>
                            
                        </div>
                        <!-- AKHIR DATE RANGE PICKER -->
                        <br>
                        <div class="row">
                            <div class="col-md-2">
                                <input type="text" class="form-control filter-input" id="first_name" name="first_name"
                                    placeholder="{{ __('employee.filterfirstname') }}" data-column="1" />
                            </div>
                            <div class="col-md-2">
                                <input type="text" class="form-control filter-input" id="last_name" name="last_name"
                                    placeholder="{{ __('employee.filterlastname') }}" data-column="2" />
                            </div>

                            <div class="col-md-3  companie-select">
                                <select name="companie_id" id="companie_id" class="form-control">
                                    <option value="">{{ trans('employee.filtercompany') }}</option>
                                    @forelse ($companies as $companie)
                                        <option value="{{ $companie->id }}">{{ $companie->name }}</option>
                                    @empty
                                        <option value="" selected>{{ trans('sell.status1') }}</option>
                                    @endforelse
                                </select>
                                @include('layouts.error', ['name' => 'item_id'])
                            </div>

                            <div class="col-md-3">
                                <input type="text" class="form-control filter-input" id="email" name="email"
                                    placeholder="{{ __('employee.filteremail') }}" data-column="4" />
                            </div>
                            <div class="col-md-2">
                                <input type="text" class="form-control filter-input" id="phone_number" name="phone_number"
                                    placeholder="{{ __('employee.filterphonenumber') }}" data-column="5" />
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-md" style="text-align: end">
                                <button type="button" name="filter" id="filter"
                                    class="btn btn-primary">{{ __('employee.btn6') }}</button>
                                <button type="button" name="refresh" id="refresh"
                                    class="btn btn-default">{{ __('employee.btn7') }}</button>
                            </div>
                        </div>

                        <br>
                        <table class="table text-center table-bordered table-striped" id="EmployeesTable">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>{{ __('employee.table1') }}</th>
                                    <th>{{ __('employee.table2') }}</th>
                                    <th>{{ __('employee.table3') }}</th>
                                    <th>{{ __('employee.table4') }}</th>
                                    <th>{{ __('employee.table5') }}</th>
                                    <th>{{ __('employee.table6') }}</th>
                                    <th>{{ __('employee.table7') }}</th>
                                    <th>{{ __('employee.table8') }}</th>
                                </tr>
                            </thead>
                            <tbody>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('script')
    <link rel="stylesheet"
        href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/css/bootstrap-datepicker.min.css">

    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/js/bootstrap-datepicker.js"></script>
    <script type="text/javascript">
        $(document).ready(function() {
            $.noConflict();
            var table = $('#EmployeesTable').DataTable({
                "processing": true,
                "serverSide": true,
                "dom": "lrtpi",
                "responsive": true,
                ajax: {
                    url: "{{ route('api.employees') }}",
                    type: 'GET',
                    data: {
                        region: "{{ Session::get('tz') }}"
                    }
                },
                "columns": [{
                        "data": "DT_RowIndex",
                        name: 'DT_RowIndex'
                    },
                    {
                        "data": "first_name"
                    },
                    {
                        "data": "last_name"
                    },
                    {
                        "data": "companie.name"
                    },
                    {
                        "data": "email"
                    },
                    {
                        "data": "phone"
                    },
                    {
                        "data": "created_at"
                    },
                    {
                        "data": "updated_at"
                    },
                    {
                        "data": "action",
                        name: 'action',
                        orderable: false,
                        searchable: false
                    }
                ]
            });
            // $('.filter-input').keyup(function() {
            //     table.column($(this).data('column'))
            //         .search($(this).val())
            //         .draw();
            // });
        });
    </script>
    <script>
        //jalankan function load_data diawal agar data ter-load
        // load_data();
        //Iniliasi datepicker pada class input
        $('.input-daterange').datepicker({
            todayBtn: 'linked',
            format: 'yyyy-mm-dd',
            autoclose: true
        });
        $('#filter').click(function() {
            var from_date = $('#from_date').val();
            var to_date = $('#to_date').val();
            var first_name = $('#first_name').val();
            var last_name = $('#last_name').val();
            var companie_id = $('#companie_id').val();
            var email = $('#email').val();
            var phone_number = $('#phone_number').val();
            if (from_date != '' && to_date != '') {
                $('#EmployeesTable').DataTable().destroy();
                load_data(from_date, to_date,first_name,last_name,companie_id,email,phone_number);
            } else {
                $('#from_date').val('');
                $('#to_date').val('');
                $('#EmployeesTable').DataTable().destroy();
                load_data('', '',first_name,last_name,companie_id,email,phone_number);
            }
        });
        $('#refresh').click(function() {
            $('#from_date').val('');
            $('#to_date').val('');
            $('#first_name').val('');
            $('#last_name').val('');
            $('#companie_id').val('');
            $('#email').val('');
            $('#phone_number').val('');
            $('#EmployeesTable').DataTable().destroy();
            load_data();
        });



        function load_data(from_date = '', to_date = '', first_name = '', last_name = '', companie_id = '', email = '',
            phone_number = '') {
            var table = $('#EmployeesTable').DataTable({
                "processing": true,
                "dom": "lrtpi",
                "serverSide": true,
                "responsive": true,
                ajax: {
                    url: "{{ route('api.employees') }}",
                    type: 'GET',
                    data: {
                        from_date: from_date,
                        to_date: to_date,
                        first_name: first_name,
                        last_name: last_name,
                        companie_id: companie_id,
                        email: email,
                        phone_number: phone_number,
                        region: "{{ Session::get('tz') }}"
                    } //jangan lupa kirim parameter tanggal 
                },
                "columns": [{
                        "data": "DT_RowIndex",
                        name: 'DT_RowIndex'
                    },
                    {
                        "data": "first_name"
                    },
                    {
                        "data": "last_name"
                    },
                    {
                        "data": "companie.name"
                    },
                    {
                        "data": "email"
                    },
                    {
                        "data": "phone"
                    },
                    {
                        "data": "created_at"
                    },
                    {
                        "data": "updated_at"
                    },
                    {
                        "data": "action",
                        name: 'action',
                        orderable: false,
                        searchable: false
                    }
                ]
            });
            // $('.filter-input').keyup(function() {
            //     table.column($(this).data('column'))
            //         .search($(this).val())
            //         .draw();
            // });
        };
    </script>
@endsection